pro SyntoolAddKeywords, header, OBSList, FRMList, FDBList, CRSList, $
  type, currentFRM, currentFDB, currentCRS, $
  nrOBSrepeats, nrFRM, nrFRMrepeats, nrFDB, $
  time, pzt, $
  sim1, sim2, sim3, sim4
  
  ;adds keywords to fits-files created by syntool.pro
  ;should correspond to IRIS fits-files level 1
  
  fxaddpar, header, 'OBSREPTO', OBSList.Repeat_Obs, 'OBS List Repeats'
  fxaddpar, header, 'OBSREPNR', nrOBSrepeats+1, 'OBS List Repeat Count'
  fxaddpar, header, 'OBSENTTO', OBSList.NumEntries, 'OBS List Number of Entries'
  fxaddpar, header, 'OBSENTNR', nrFRM+1, 'OBS List Entry Count'
  fxaddpar, header, 'FRMREPTO', (*(OBSList).Repeat_FRM)[nrFRM], 'FRM List Repeats'
  fxaddpar, header, 'FRMREPNR', nrFRMrepeats+1, 'FRM List Repeat Count'
  fxaddpar, header, 'FRMENTTO', FRMList[currentFRM].NumEntries, 'FRM List Number of Entries'
  fxaddpar, header, 'FRMENTNR', nrFDB+1, 'FRM List Entry Count'
  
  fxaddpar, header, 'OBSID', OBSList.ID, 'OBS List ID'
  fxaddpar, header, 'FRMID', FRMList[currentFRM].ID, 'FRM List ID'
  fxaddpar, header, 'FDBID', FDBList[currentFDB].ID, 'FDB List ID'
  fxaddpar, header, 'CRSID', CRSList[currentCRS].ID, 'CRS List ID'
  
  fxaddpar, header, 'TIME', time, 'Time [s]'
  fxaddpar, header, 'PZTX', pzt[0], 'PZT X [arcsec]'
  fxaddpar, header, 'PZTY', pzt[1], 'PZT Y [arcsec]'
  case type of
  0: typetext='SJI'
  1: typetext='NUV'
  2: typetext='FUV'
  endcase
  fxaddpar, header, 'TYPE', typetext
  
  fxaddpar, header, 'FW', (*(FRMList[currentFRM]).FW)[nrFDB], 'Filterwheel Position'
  fxaddpar, header, 'EXPDURAT', FDBList[currentFDB].Exp_Duration, 'Exposure Duration'
  fxaddpar, header, 'SUMSPEC', CRSList[currentCRS].Spectral, 'Spectral Sum'
  fxaddpar, header, 'SUMSPAT', CRSList[currentCRS].Spatial, 'Spatial Sum'
  
  fxaddpar, header, 'REGTOT', CRSList[currentCRS].SubRegions, 'Number of Regions'
  for i=0,CRSList[currentCRS].SubRegions-1 do begin
    number=string(i+1,format='(I1)')
    fxaddpar, header, 'ROWSTAR'+number, (*(CRSList[currentCRS]).StartRow)[i], 'Startrow for Region '+number
    fxaddpar, header, 'ROWNUM'+number, (*(CRSList[currentCRS]).NumRows)[i], 'Number of Rows for Region '+number
    fxaddpar, header, 'COLSTAR'+number, (*(CRSList[currentCRS]).StartCol)[i], 'Startcolumn for Region '+number
    fxaddpar, header, 'COLNUM'+number, (*(CRSList[currentCRS]).NumCols)[i], 'Number of Columns for Region '+number
  endfor
  
  fxaddpar, header, 'SIMFILE1', sim1, 'Input 1 from FUV Simulation'
  fxaddpar, header, 'SIMFILE2', sim2, 'Input 2 from FUV Simulation'
  fxaddpar, header, 'SIMFILE3', sim3, 'Input 1 from NUV Simulation'
  fxaddpar, header, 'SIMFILE4', sim4, 'Input 2 from NUV Simulation'

end
